/*
 * InputHandlerAgent.java
 *
 * Created on 14 novembre 2004, 17.09
 */
package com;

import alice.tucson.api.*;
import alice.logictuple.*;
import alice.tuprolog.*;
import java.util.*;
import java.io.*;


/**
 *
 * @author  stefano olivieri
 */
public class InputHandlerAgent extends alice.tucson.api.Agent {
    
   /*Conterr la lista dei task*/
    java.util.Vector listName;

    /*Vettore delle teorie*/
    java.util.Vector listTheory;
    
    /*Vettore delle dipendenze*/
    java.util.Vector listdepends;
    
    /*Vettore dei domini*/
     java.util.Vector listdomains;
     
     /*Tuple Centre control*/
     TupleCentreId tidControl;
     
     /*Tuple Centre theory*/
     TupleCentreId  tidTheory ;
     
     /*Tuple Centre domains*/
     TupleCentreId tidDomain;
    
     /*Tuple Centre graph*/
     TupleCentreId tidGraph;
     
    
    
    public InputHandlerAgent( alice.tucson.api.AgentId aid )throws Exception{
        
         super(aid);
         try{
             this.listName= new Vector();
             this.listTheory= new Vector();
             this.listdepends= new Vector();
             tidControl = new TupleCentreId("control");
             tidTheory = new TupleCentreId("theory");
             tidDomain = new TupleCentreId("domains");
             tidGraph  = new TupleCentreId("graph");
             
            
                  
        }catch(Exception e ){e.printStackTrace();}
    }//InputHandlerAgent
    
    
    protected void body() {
         
        try{
           
            /*Scopo dell'agente, recepire la descrizione dei subtask che risolvono il problema,
             *ottenere il dominio del problema e gestirlo dipendentemente dal numero di agenti
             *o dalle dimensioni del dominio stesso*/
         
              
              InsertTaskGUI insertGUI = new InsertTaskGUI();
              insertGUI.show();
              
               
              /*Ora l'Agente si arresta, aspetta che l'utente termini di inserire i parametri,
               Sincronizzazione della GUI.*/
              
              this.in(tidControl,new LogicTuple(new Value("initialization_ended")));
              
              /*Recupero dell'input*/
              this.listName = insertGUI.getTasksName();
              this.listTheory = insertGUI.getTasksTheory();
              this.listdepends = insertGUI.getDependency();
              this.listdomains = insertGUI.getlistDomain();
              
              
              
              
              /*Invio le informazioni in  diversi tuple centre a seconda della loro tipologia*/
               
              /*tuple centre relativo alle dipendenze di ogni sottotask: graph
               *il vettore  formato da coppie del tipo padre-figlio, contiene un numero pari di entry
               */
              if(this.listdepends.size() % 2 == 0){
                  for(int i=0; i<this.listdepends.size();i+=2){
                      
                    /*tuple centre graph: graph(father,son)*/
                   this.out(this.tidGraph,new LogicTuple(new Value("arch",new Value(((String)this.listdepends.get(i))),new Value( (String)this.listdepends.get(i+1) ) ))); 
                  }
              }
              
              /*tuple centre relativo alle teorie di ogni sottotask: theory*/
               for(int i=0; i<this.listTheory.size();i++){
               
                   /*Recupero il contenuto del file*/
                   String result = this.getContentFile((File)(this.listTheory.get(i)));
                  
                  
                   /*tuple centre theory: theory(nameTask,TheoryValue)*/
                   this.out(tidTheory, new LogicTuple(new Value("theory",new Value((String)this.listName.get(i)),new Value(result))));
                                       
             
                   /*tuple centre relativo dominio del problema: domains*/
                   result = this.getContentFile((File)(this.listdomains.get(i)));
                   
                   /*A partire dal file di specifica del dominio creo gli elementi atomici del dominio*/ 
                   result = result.replace('.', '');
                   String[] atom = result.split("");
                   
                   //Scrivo nel tuple centre domains: riporto il contenuto del file
                   if(!result.equals(""))
                   for(int a=0;a<atom.length;a++){
                      this.out(tidDomain, new LogicTuple(new Value("domains",new Value((String)this.listName.get(i)),TupleArgument.parse(atom[a]))));}
           }//for
              
              /*Sincronizazzione indiretta con TaskSelectorAgent: un worker agent accede al sistema solo
               se il sistema  pronto*/ 
              this.out(tidControl,new LogicTuple(new Value("system_ready")));
              
        }catch(Exception e ){e.printStackTrace();}
    
    }//body
    
    
    /*Utility: preleva il contenuto di un file e lo restituisce in formato stringa*/
    private String getContentFile(File file){
        
        String result = new String();
        try{
            String tmp = new String();
            BufferedReader in  = new BufferedReader(new FileReader(file));
            while((tmp=in.readLine())!= null){ result+=tmp;}
        }catch(Exception e ){e.printStackTrace();}
        return result;
    
    }
    
  
        public static void main(String[] args) throws Exception {
            
             /*IdAgent Value*/
            String idAgent = "inputHandlerAgent";
     
            /*AgentId*/
            alice.tucson.api.AgentId aid = new  alice.tucson.api.AgentId(idAgent);
            
            new InputHandlerAgent(aid).spawn();
            }
        
}
    

