/*
 * AgentInput.java
 *
 * Created on 14 novembre 2004, 17.09
 */
package com;

import alice.tucson.api.*;
import alice.logictuple.*;
import alice.tuprolog.*;


/**
 * @author  stefano olivieri
 * Il suo compito  quello di relazionarsi con gli agenti che entrano nel sistema e sono
 * propensi a svolgere attivit, TaskHandlerAgent assegna i task agli agenti worker che arrivano.
 * TaskHandlerAgent deve poter conoscere le teorie  relative a ogni task per poterle assegnare
 * inoltre deve poter conoscere le dipendenze per assegnare eventuali risultati precedenti a nuovi task.
 */
public class TaskHandlerAgent extends alice.tucson.api.Agent {
    
   
    /*Tuple Centre control*/
    TupleCentreId tidControl;
    
    /*Tuple Centre theory*/
    TupleCentreId  tidTheory;
     
    /*Tuple Centre domains*/
    TupleCentreId tidDomain;
    
    /*Tuple Centre graph*/
     TupleCentreId tidGraph;
     
     /*Theory*/
     String theory_text;
     
     /*Result*/
     String res; 
    
   
   
    
    public TaskHandlerAgent(alice.tucson.api.AgentId aid )throws Exception{
    
        super(aid);
     
        try{
       
        tidControl = new TupleCentreId("control");
        tidTheory = new TupleCentreId("theory");
        tidDomain = new TupleCentreId("domains");
        tidGraph  = new TupleCentreId("graph");
        
        
        }catch(Exception e){e.printStackTrace();}
        
     }//TaskHandlerAgent
    
    
   protected void body() {
        
          try {
              
              /*CICLO INFINITO*/
            while (true) {
                alice.logictuple.Var idAgent = new alice.logictuple.Var("IdAgent");
                alice.logictuple.Var taskName = new alice.logictuple.Var("TaskName");
                alice.logictuple.Var idSequence = new alice.logictuple.Var("IdSequence");
                alice.logictuple.Var theoryCurrent = new  alice.logictuple.Var("Theory");
                alice.logictuple.Var domainsCurrent = new  alice.logictuple.Var("Domains");
                alice.logictuple.Var solutionToAdd =new  alice.logictuple.Var("Solution");


                /*Stringhe theory_text e res che conterranno rispettivamente la teoria da elaborare e il risultato dell'elaborazione*/
                theory_text = new String();
                res = new String();
            
                
                /*In attesa (bloccante) che un agente worker arrivi e si renda disponibile e che 
                 *esista un task da assegnare*/

                 this.in(tidControl,new LogicTuple("start",taskName,idSequence));
               

                 /*Occorre redarre il descrittore, teoria, dominio richiesti ed eventuali risultati:
                 *occorrono i risultati dei task da cui quello corrente dipende in maniera diretta*/

                 /*Relazioni tra i task, viene aggiunta la descrizione del grafo nella teoria ed i risultati*/
                 this.theory_text = this.addDependencyAndResult(this.theory_text);


                 /*Lista delle dipendenze dirette del task indicato, prelevo i risultati dei task padre*/
                 res = this.getParentsResult(this.theory_text,taskName,idSequence);
         
                 /*Recupero la teoria associata al task da assegnare e aggiungo alla teoria*/
                 this.rd(tidTheory,new LogicTuple("theory",taskName.getVarValue("TaskName"),theoryCurrent ));

                 /*Recupero il dominio associato al task da assegnare e aggiungo alla teoria*/
                 this.inp(tidDomain,new LogicTuple("domains",taskName.getVarValue("TaskName"),domainsCurrent ));
                 
                  /*Il descrittore  ultimato*/
                 
                 if(domainsCurrent.toString().equals("Domains"))
                     this.out(tidControl,new LogicTuple("task_descriptor",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"),new Value(theoryCurrent.toString()),new Value(""),new Value(res)));
                 else
                     this.out(tidControl,new LogicTuple("task_descriptor",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"),new Value(theoryCurrent.toString()),new Value(domainsCurrent.toString()+"."),new Value(res)));

                }//while

            } catch (Exception ex){ex.printStackTrace();}
    
        
    
        }//body
   
   
   private String addDependencyAndResult(String theory_text){
       try{
           
        /*Insieme delle dipendenze: struttura del grafo*/
        LogicTuple ltdepends = LogicTuple.parse("rd_all(arch(X,Y),L)");
        ltdepends =  this.inp( tidGraph ,ltdepends);
        
        /*Insieme dei risultati*/
        LogicTuple ltresult = LogicTuple.parse("rd_all(result(TaskN,IdSeq,Dom,Val),L)");
        ltresult =  this.inp( tidControl ,ltresult);

         /*Lista delle dipendenze*/
        TupleArgument[] taDepends = null;
        if(ltdepends != null){
            taDepends = ltdepends.getArg(1).toArray(); ltdepends=null;}
        
       
        /*Lista dei risultati*/
        TupleArgument[] taRes = null;
        if(ltresult != null){
            taRes = ltresult.getArg(1).toArray(); ltresult = null;}
        
        /*Aggiungo la struttura del grafo*/
         if(taDepends != null)
             for(int i=0; i<taDepends.length;i++){
                 
                 theory_text += taDepends[i].toString() + ". \n";
             }//for
        
        
        
        /*Aggiungo i risultati*/
        if(taRes != null)
            for(int i=0; i<taRes.length;i++){
            
                theory_text += taRes[i].toString() + ". \n";
                
            }//for
       
        
       }catch(Exception e){e.printStackTrace();}
       
        return theory_text;
       
   }//findDependency
   
   private String getParentsResult(String theory_text, alice.logictuple.Var taskName, alice.logictuple.Var idSequence){
       
     
            //Conterr il risultato
            String result_theory  = new String();
       try{
        
            alice.logictuple.Var parent =  new   alice.logictuple.Var("Parent");
            alice.logictuple.Var result =  new alice.logictuple.Var("Res");
          
            /*Teoria necessaria a recuperare la dipendenza di primo grado, genitori*/
            theory_text +="parents(NODE,GEN) :-setof(X,arch(X,NODE),GEN),!.\n"+
            "parents(NODE,[]):-not arch(X,NODE).\n"+
            "goal(Parent,Son,IdSequence,Domains,Result) :-\n"+
            "parents(Son,Parents),\n"+
            "member(Parent,Parents),\n"+
            "result(Parent,IdSequence,Domains,Result).\n";
          
          
            
            Theory theory = new Theory(theory_text);
            Prolog engine=new Prolog(new String[]{"alice.tuprolog.lib.BasicLibrary","alice.tuprolog.lib.ISOLibrary"});
            
            /*Setto la teoria*/
            engine.setTheory(theory);

            /*Found dependency*/
            SolveInfo info = engine.solve("goal(Parent,"+taskName.toString()+","+idSequence.getVarValue("IdSequence")+","+"Domains,Res).");
            
            /*Verifico se esiste soluzione*/
            while (info.isSuccess()){
            result_theory += "result(" + info.getTerm("Parent").toString() + "," +idSequence.getVarValue("IdSequence") + "," + info.getTerm("Domains").toString() +"," + info.getTerm("Res").toString() + ").";
             
                if (engine.hasOpenAlternatives()){
                    info=engine.solveNext();  
 
                    } 
                else break;
            }//while
            
           
                
            }catch(Exception e){e.printStackTrace();}
       
           return result_theory;
          
         
   
   
   }//getParents
   
  
  
        public static void main(String[] args) throws Exception {
            
            /*IdAgent Value*/
            String idAgent = "taskHandlerAgent ";
     
            /*AgentId*/
            alice.tucson.api.AgentId aid = new  alice.tucson.api.AgentId(idAgent);
            
            new  TaskHandlerAgent (aid).spawn();
            }
        
}//TaskHandlerAgent
    

