/*
 * AgentInput.java
 *
 * Created on 14 novembre 2004, 17.09
 */
package com;

import alice.tucson.api.*;
import alice.logictuple.*;
import alice.tuprolog.*;


/**
 *
 * @author  stefano olivieri
 */
public class TaskSelectorAgent extends alice.tucson.api.Agent {
    
     /*Sequenza di riferimento,  la prima a non essere ancora terminata */
     static  int idSequence = 0;
     
     /*Tuple Centre control*/
     TupleCentreId tidControl;
      
     /*Tuple Centre domains*/
     TupleCentreId tidDomain;
     
     /*Tuple Centre graph*/
     TupleCentreId tidGraph;
     
     /*Tuple Centre theory*/
     TupleCentreId  tidTheory ;
     
     /*Fissata una sequenza rappresenta il numero di task terminati*/
     int endedTask=0; 
     
     /*Fissata una sequenza rappresenta il numero di task terminati*/
     int doingTask=0; 
     
     /*Numero totale dei task.*/
     int numTask=0;
     
   
    
    
    public TaskSelectorAgent(alice.tucson.api.AgentId aid )throws Exception{
    
        super(aid);
        tidControl = new TupleCentreId("control");
        tidDomain = new TupleCentreId("domains");
        tidGraph  = new TupleCentreId("graph");
        tidTheory = new TupleCentreId("theory");
       
    }//AgentInput
    
    
   protected void body() {
        
        
          try { 
              
            this.initialize();
            
            /*CICLO INFINITO*/
           
            while (true) {
            
                alice.logictuple.Var idAgent = new alice.logictuple.Var("IdAgent");
               

                /*L'utente che termina e/o arriva scrive ready(idAgent)*/
                LogicTuple lgReady = new LogicTuple("ready",idAgent);
 
                /*In attesa di un agente disponibile*/    
                LogicTuple taskEnd =  this.in(tidControl,lgReady);
             
                /*Determinazione del prox task da assegnare: creo teoria Prolog con l'insieme delle
                 *dipendenze tra i task, quelli terminati e quelli in corso di esecuzione*/
                 
                /*Calcolo il numero dei task presenti, ogni task ha la propria teoria*/
                LogicTuple lttheory = LogicTuple.parse("rd_all(theory(X,Y),L)");
                lttheory  =  this.inp( tidGraph ,lttheory );
           
                /*Insieme delle dipendenze: struttura del grafo*/
                LogicTuple ltdepends = LogicTuple.parse("rd_all(arch(X,Y),L)");
                ltdepends =  this.inp( tidGraph ,ltdepends);
                
                 /*Insieme delle task in corso di esecuzione fissata una seq.*/
                LogicTuple ltdoing = LogicTuple.parse("rd_all(doing(Y,"+this.idSequence+"),L)");
                ltdoing = this.inp(tidControl,ltdoing);
                
                /*Insieme dei task terminati, fissata una seq*/
                LogicTuple ltend = LogicTuple.parse("rd_all(end(_,TaskType,"+this.idSequence+"),L)");
                ltend =  this.inp(tidControl,ltend);
                
                /*Numero complessivo dei task*/
                TupleArgument[] taTheory = null;
                 if(lttheory != null){
                    taTheory = ltdepends.getArg(1).toArray();
                    this.numTask = taTheory.length+1;}
                

                /*Lista delle dipendenze*/
                TupleArgument[] taDepends = null;
                if(ltdepends != null)
                    taDepends = ltdepends.getArg(1).toArray();
                  
                
                /*Lista dei task in progress*/
                TupleArgument[] taDoing = null;
                if(ltdoing != null){
                    taDoing =ltdoing.getArg(1).toArray(); 
                    this.doingTask = taDoing.length;}
               
                /*Lista dei task terminati*/
                TupleArgument[] taEnd = null;
                if(ltend != null){
                    taEnd =ltend.getArg(1).toArray();
                    this.endedTask = taEnd.length;}
                   

                /*Creo la teoria, risolutore Prolog che determina il next task da attivare*/
                String theory_text = new String();
                
                /*Aggiungo l'insieme dei task in esecuzione*/
                if(taDoing!= null)
                    for(int i=0; i<taDoing.length;i++){
            
                     theory_text += taDoing[i].toString() + ".\n";
                    }

                /*Aggiungo la struttura del grafo*/
                if(taDepends != null)
                    for(int i=0; i<taDepends.length;i++){

                     theory_text += taDepends[i].toString() + ".\n";
                  
                    }

            
                /*Aggiungo l'insieme dei task terminati*/
                 if(taEnd!= null)
                     for(int i=0; i<taEnd.length;i++){

                     theory_text += taEnd[i].toString() + ".\n";
                      

                    }
            
          
            
              /*Algoritmo di selezione: sceglie il prox task in funzione delle dipendenze, dei task
               *terminati ed in esecuzione, tiene inoltre conto della sequenza attuale*/
                theory_text += "end_all([],IdSeq).\n"+ 
                    "end_all([H|T],IdSeq) :- end(IdAgent,H,IdSeq),end_all(T,IdSeq).\n"+
                    "parents(NODE,GEN) :-setof(X,arch(X,NODE),GEN),!.\n"+
                    "parents(NODE,[]):-not arch(X,NODE).\n"+
                    "start(TasktoStart,IdSeq) :- arch(TasktoStart,Y),not end(IdAgent,TasktoStart,IdSeq),not doing(TasktoStart,IdSeq),parents(TasktoStart,[]),!.\n"+
                    "start(TasktoStart,IdSeq) :- (arch(TasktoStart,D);arch(D,TasktoStart)),not end(IdAgent,TasktoStart,IdSeq),not doing(TasktoStart,IdSeq),parents(TasktoStart,List),end_all(List,IdSeq),!.\n";


                /*creazione della teoria*/
                Theory theory = new Theory(theory_text);
                Prolog engine=new Prolog(new String[]{"alice.tuprolog.lib.BasicLibrary"});

               /*Setto la teoria*/

                engine.setTheory(theory);
                    
                SolveInfo info = engine.solve("start(X,"+this.idSequence+").");
                Term solution=null;
                /*Verifico se esiste soluzione*/
                if(info.isSuccess()){
                    solution = info.getSolution();
                    
                    }
                    
                else {
                    
                    /*Nel caso in cui una seq sia terminata ne inizio una nuova*/
                    if(this.endedTask + this.doingTask == this.numTask){
                        this.idSequence++;
                        
                        /*Nuova soluzione*/
                        info = engine.solve("start(X,"+this.idSequence+").");
                        solution = info.getSolution();
                     
                    }
                    /*Caso in cui tutti i task indipendenti di una seq. sono terminati ma la seq non  ancora terminata*/
                    else  this.out(tidControl,lgReady);
                
                }//else

                    /*Scrivo nel TupleCenter il prossimo task da inizializzare*/
                    if(solution!=null){
                      this.out(tidControl,new LogicTuple(new Value("start",new Value(((Struct)solution).getArg(0).toString()),new Value(this.idSequence))));
                      this.out(tidControl,new LogicTuple(new Value("doing",new Value(((Struct)solution).getArg(0).toString()),new Value(this.idSequence))));
                      
                    }


            }//while
           
        } catch (Exception ex){ex.printStackTrace();}
    
        
    
    }//body
   
   /*Setta le reazioni*/
   private void initialize() throws Exception{
       
       String rdall ="reaction(inp(rd_all(T,L)),(pre,out_r(rdall_collect(T,[])))).\n"+
                            "reaction(out_r(rdall_collect(T,L)),("+
                            "current_tuple(rdall_collect(T1,_)),"+
                            "in_r(T1),"+
                            "in_r(rdall_collect(T,L)),"+
                            "out_r(rdall_collect(T,[T1|L])))).\n"+
                            "reaction(out_r(rdall_collect(T,_)),("+
                            "current_tuple(rdall_collect(T1,_)),"+
                            "no_r(T1),"+
                            "in_r(rdall_collect(T,L)),"+
                            "out_r(rd_all(T,L)),"+
                            "out_r(rdall_restore(L)) )).\n"+
                            "reaction(out_r(rdall_restore([])),("+
                            "in_r(rdall_restore([])) )).\n"+
                            "reaction(out_r(rdall_restore([H|T])),("+
                            "in_r(rdall_restore([H|T])),"+
                            "out_r(H),"+
                            "out_r(rdall_restore(T)) )).\n";
       
       this.setSpec(tidGraph,rdall);
       this.setSpec(tidControl,rdall);
       this.setSpec(tidTheory,rdall);
   
      
   }//initialize
    
  
        public static void main(String[] args) throws Exception {
            
           
             /*IdAgent Value*/
            String idAgent = " taskSelectorAgent";
     
            /*AgentId*/
            alice.tucson.api.AgentId aid = new  alice.tucson.api.AgentId(idAgent);
            
            new  TaskSelectorAgent(aid).spawn();
            }
        
}
    

