/*
 * WorkerAgent.java
 *
 * Created on 28 novembre 2004, 9.56
 */

package com;

import alice.tucson.api.*;
import alice.logictuple.*;
import alice.tuprolog.*;
import javax.swing.*;


/**
 *
 * @author  stefano olivieri
 */
public class WorkerAgent extends alice.tucson.api.Agent  {
    
    
     /*Tuple Centre control*/
     TupleCentreId tidControl;
     
   
     /*Var.istanza*/
     alice.logictuple.Var taskName; 
     alice.logictuple.Var idSequence; 
     alice.logictuple.Var theoryCurrent;
     alice.logictuple.Var domainsCurrent; 
     alice.logictuple.Var resCurrent; 
     
   
    
    /** Creates a new instance of WorkerAgent */
    public WorkerAgent(alice.tucson.api.AgentId aid )throws Exception{
    
        super(aid);
       
        try{ 
            this.tidControl = new TupleCentreId("control");
        
        }catch(Exception e ){e.printStackTrace();}
        
    }
    
   protected void body() {
        
        
          try { 
              
             /*L'agente aspetta che il sistema sia pronto a recepirlo*/ 
             this.rd(tidControl,new LogicTuple(new Value("system_ready")));
             
             JOptionPane.showConfirmDialog(null,"A WorkerAgent was entered.","Information",JOptionPane.DEFAULT_OPTION,JOptionPane.INFORMATION_MESSAGE);
             
            /*ready(idAgent)*/
            this.out(tidControl,new LogicTuple("ready",new TupleArgument(this.getId().toTerm())));     
       
           
            /*CICLO INFINITO*/
            while (true) {
                taskName = new  alice.logictuple.Var("TaskName");
                idSequence = new  alice.logictuple.Var("IdSequence");
                theoryCurrent = new  alice.logictuple.Var("Theory");
                domainsCurrent = new  alice.logictuple.Var("Domains");
                resCurrent = new  alice.logictuple.Var("Result");
            
           
                this.in(tidControl,new LogicTuple("task_descriptor",taskName,idSequence,theoryCurrent,domainsCurrent,resCurrent));
                
                System.out.println(makeTheory(theoryCurrent,domainsCurrent,resCurrent));
                Theory theory = new Theory(makeTheory(theoryCurrent,domainsCurrent,resCurrent));
                Prolog engine=new Prolog(new String[]{"alice.tuprolog.lib.BasicLibrary","alice.tuprolog.lib.ISOLibrary"});

                 /*Setto la teoria*/
                engine.setTheory(theory);

                /*Risoluzione, la query  posta nel formato: nometask(Solution).*/ 
                SolveInfo info = engine.solve((taskName.getVarValue("TaskName").toString())+"(Solution).");
 
                /*Verifico se esiste soluzione*/
                while (info.isSuccess()){
                      
                    this.out(tidControl,new LogicTuple("result",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"),domainsCurrent.getVarValue("Domains"),new Value(Integer.parseInt(info.getTerm("Solution").toString()))));
                  
                    if (engine.hasOpenAlternatives()){
                        info=engine.solveNext();  
                        } 
                    else break;
                }//while
                
                /*Se non esiste soluzione*/
               if(!info.isSuccess()){
                     this.out(tidControl,new LogicTuple("result",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"),domainsCurrent.getVarValue("Domains"),new Value("no_solution")));     
               }//else
                
               this.in(tidControl,new LogicTuple("doing",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"))); 
               this.out(tidControl,new LogicTuple("end",new TupleArgument(this.getId().toTerm()),taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence")));
               this.out(tidControl,new LogicTuple("ready",new TupleArgument(this.getId().toTerm())));
       
            }//while
          }catch(Exception e){e.printStackTrace();
            try{
            this.out(tidControl,new LogicTuple("result",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"),domainsCurrent.getVarValue("Domains"),new Value("no_solution")));   
            this.in(tidControl,new LogicTuple("doing",taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence"))); 
            this.out(tidControl,new LogicTuple("ready",new TupleArgument(this.getId().toTerm())));
            this.out(tidControl,new LogicTuple("end",new TupleArgument(this.getId().toTerm()),taskName.getVarValue("TaskName"),idSequence.getVarValue("IdSequence")));
              
            }catch(Exception ex){ex.printStackTrace();}
             }
          
     }//body() 
   
   
   /*Rende la teoria consultabile da un motore Prolog*/ 
   private String makeTheory(alice.logictuple.Var theoryCurrent,alice.logictuple.Var domainsCurrent,alice.logictuple.Var resCurrent){
       
           String tmp = new String();
           String temp = new String();
           
           alice.logictuple.Var[] ar = {theoryCurrent,domainsCurrent};
           
          /*Elimino la notazione delle stringhe in Prolog cio: 'str'*/
           for(int i=0; i< ar.length;i++){
               temp=ar[i].toString().replace('\'',' ');
               temp = temp.replace('.', '');
               temp = temp.replaceAll("", ".\n");
               tmp+=temp;
           }
           
        
           /*Immetto i risultati precedenti*/
          
           if(!resCurrent.toString().startsWith("''")){
           temp=resCurrent.toString().replace('\'',' ');
           temp = temp.replace('.', ' ');
           temp = temp.replaceAll("", ".\n");
           tmp+=temp;
           }
       
          return tmp;
           
   
   }//makeTheory
   
   
     
       public static void main(String[] args) throws Exception {
            
            /*IdAgent Value*/
            String idAgent = "workerAgent";
     
            /*AgentId*/
            alice.tucson.api.AgentId aid = new  alice.tucson.api.AgentId(idAgent);
            
            new  WorkerAgent(aid).spawn();
            
           
          
            }
    
}
